package edu.nps.moves.dis7.enumerations;

import java.nio.ByteBuffer;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import edu.nps.moves.dis7.*;

/**
 * Generated from XML, SISO-REF-010-v25, 2018-08-29<br>
 * UID 377 marshal size 8<br>
 * Grid Axis Descriptor-Axis Type
 */
public enum GridAxisDescriptorAxisType 
{
    /** Regular Axis */
    REGULAR_AXIS (0, "Regular Axis"),
    /** Irregular Axis */
    IRREGULAR_AXIS (1, "Irregular Axis");

    private int value;
    private final String description;

    GridAxisDescriptorAxisType(int value, String description)
    {
        this.value = value;
        this.description = description;
    }

    public int getValue()
    {
        return value;
    }

    public String getDescription()
    {
        return description;
    }
    
    public static int getEnumBitWidth()
    {
      return 8;
    }

    public static GridAxisDescriptorAxisType getEnumForValue(int i)
    {
       for(GridAxisDescriptorAxisType val: GridAxisDescriptorAxisType.values()) {
          if(val.getValue()==i)
              return val;
       }
       System.err.println("No enumeration found for value " + i + " of enumeration GridAxisDescriptorAxisType");
       return null;
    }


    public void marshal(DataOutputStream dos) throws IOException
    {
        dos.writeByte(getValue());
    }
    
    public void marshal(ByteBuffer buff) throws Exception
    {
        buff.put((byte)getValue());
    }

    public static GridAxisDescriptorAxisType unmarshalEnum (DataInputStream dis) throws Exception
    {
       /* try {
            value = dis.readUnsignedByte();
        }
        catch(IOException ex) {
            showError(ex);
        } */
        
        return getEnumForValue(dis.readByte());
    } 

    public static GridAxisDescriptorAxisType unmarshalEnum(ByteBuffer buff) throws Exception
    {
        /*
        try {
            value = (int)buff.get();
        }
        catch(Exception ex) {
            showError(ex);
        }
        */
        return getEnumForValue(buff.get());
    }

    public int getMarshalledSize()
    {
        return 1; // 8 bits
    }
    
    @Override
    public String toString()
    {
        return "GridAxisDescriptorAxisType: " + name() + ": " + getValue(); 
    }
}
